/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_PLANET_ORIENTATION_H__
#define __MTK_PLANET_ORIENTATION_H__
#include  "../common/math/vector3.h"
#include  "../common/math/quaternion.h"


//----------
//  Update
//----------
void	update_planets_and_satellites_orientation(const double& t);

//-----------
//  Planets
//-----------
matrix3d	get_planet_ec_to_pl_matrix0(int idx);
matrix3d	get_planet_ec_to_pl_matrix(int idx);
matrix3d	get_planet_pl_to_ec_matrix0(int idx);
matrix3d	get_planet_pl_to_ec_matrix(int idx);
void		get_planet_bases(int idx, vector3d& ex, vector3d& ey, vector3d& ez);

vector3d	get_planet_nv_ec(int idx, const double& lon, const double& lat);
vector2d	get_planet_lon_lat_ec(int idx, const vector3d& nv);

quaterniond	get_planetarium_ori(int idx, const double& lon, const double& lat, const double& azim, const double& alti);
quaterniond	get_ori_from_planetarium_dirc(int idx, const double& lon, const double& lat, const double& thd);
double		get_dirc_from_3D_ori(int idx, const quaterniond& ori);

//--------------
//  Satellites
//--------------
matrix3d	get_satellite_ec_to_sat_matrix(int idx);
matrix3d	get_satellite_sat_to_ec_matrix(int idx);
void		get_satellite_bases(int idx, vector3d& ex, vector3d& ey, vector3d& ez);
vector2d	get_satellite_lon_lat_ec(int idx, const vector3d& nv);


#endif
